' Licensed Materials - Property of IBM
'
' (C) Copyright IBM Corp. 2008, 2012 All Rights Reserved
'
' US Government Users Restricted Rights - Use, duplicate or
' disclosure restricted by GSA ADP Schedule Contract with
' IBM Corp.

'==============================
' Initialize
'==============================
Const HKEY_LOCAL_MACHINE = &H80000002
strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\"
Dim objReg, keySet

Set objReg = GetRegObj(32)
objReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, arrSubKeys
Set keySet = CreateObject("Scripting.Dictionary")

For Each strSubKey in arrSubKeys
  keySet.Add strSubKey, True    'Mark this subkey has been handled. For Win-64bit, there are some duplicate
                                'in both "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" and 
                                '"HKEY_LOCAL_MACHINE\Wow6432Node\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" 
  If IsSystemComponent(strSubKey) = False Then
    Call OutPutResult(objReg, strSubKey)
    On Error Resume Next
  End If
Next

Set objReg = GetRegObj(64)
objReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, arrSubKeys
For Each strSubKey in arrSubKeys
  If keySet(strSubKey) <> True And IsSystemComponent(strSubKey) = False Then      
    Call OutPutResult(objReg, strSubKey)
    On Error Resume Next
  End If
Next

'==============================
' OutPutResult
'==============================
Sub OutPutResult(ByRef objReg, ByVal strSubKey)
  objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath & strSubkey, "DisplayName", dispNameVal
  objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath & strSubkey, "DisplayVersion", versionVal
  objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath & strSubkey, "Publisher", vendorVal
  objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath & strSubkey, "InstallDate", instDateVal
  objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath & strSubkey, "InstallLocation", instLocVal
  WScript.StdOut.WriteLine strSubKey & "|" & dispNameVal & "|" & versionVal & "|" & vendorVal & "|" & instDateVal & "|" & instLocVal
End Sub

'==============================
' GetRegObj
' return an regitery object according to different winOS bit
'==============================
Function GetRegObj(bit)
  Dim oCtx, oLocator
  Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
  oCtx.Add "__ProviderArchitecture", bit
  Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
  Set GetRegObj = oLocator.ConnectServer("", "root\default", "", "", , , , oCtx).Get("StdRegProv")
End Function
 
'==============================
' IsSystemComponent
'==============================
Function IsSystemComponent(subKey)
  IsSystemComponent = False
  objReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPath & subKey, "SystemComponent", sysCompVal
  If IsNull(sysCompVal) = False Then
    If sysCompVal = 1 Then
      IsSystemComponent = True
    End If
  End If
End Function
